  MEMBER('test.clw')
  MAP
    MODULE('Windows.DLL')
      ShellExecute (UNSIGNED, *CSTRING, *CSTRING, *CSTRING, *CSTRING,  |
                SIGNED), UNSIGNED, PASCAL, RAW, NAME('ShellExecuteA')
    END
  END

ExcelDDE.Init PROCEDURE(STRING tn, STRING tp, STRING rp, LONG t)
  CODE
  SELF.TplName &= NEW(STRING(255))
  SELF.TplPath &= NEW(STRING(255))
  SELF.RptPath &= NEW(STRING(255))
  SELF.pOutStr &= NEW(STRING(1000))
  SELF.RepVals &= NEW(ReplaceValues)
  SELF.TplName = tn
  SELF.TplPath = tp
  SELF.RptPath = rp
  SELF.TimeOut = t
!--------------------------------------------------------------------
ExcelDDE.Kill PROCEDURE
  CODE
  FREE(SELF.RepVals)
  DISPOSE(SELF.TplName)
  DISPOSE(SELF.TplPath)
  DISPOSE(SELF.RptPath)
  DISPOSE(SELF.RepVals)
  DISPOSE(SELF.pOutStr)
  DDECLOSE(SELF.DDEChannel)
!--------------------------------------------------------------------
ExcelDDE.OpenTemplate PROCEDURE
TempFileName         STRING(255)
WaitTime             LONG
!   ShellExecute
lpOperation          CSTRING('Open')
lpFileName           CSTRING(128)
lpParameters         CSTRING(128)
lpDirectory          CSTRING(128)
HWND                 UNSIGNED
DebugMode            BYTE
  CODE
  !     Excel
  SELF.DDEChannel = 0
  lpFileName = CLIP(SELF.TplPath) & CLIP(SELF.TplName) & '.xls'
  HWND=TARGET{PROP:HANDLE}
  IF ShellExecute(HWND, lpOperation, lpFileName, lpParameters, lpDirectory, DebugMode)
    !   
    WaitTime = CLOCK() + SELF.TimeOut
    LOOP WHILE SELF.DDEChannel = 0
      SELF.DDEChannel = DDECLIENT('Excel', CLIP(SELF.TplName) & '.xls')
      IF CLOCK() > WaitTime
        RETURN
      END
    END
    IF SUB(SELF.RptPath, LEN(CLIP(SELF.RptPath)), 1) <> '\'
      SELF.RptPath = CLIP(SELF.RptPath) & '\'
    END
    TempFileName = CLIP(SELF.RptPath) & CLIP(SELF.TplName) & ' ' & |
                      FORMAT(TODAY(), @D5-) & ' ' & FORMAT(CLOCK(), @T4-) & '.xls'
    DDEEXECUTE(SELF.DDEChannel,'[Save.As("' & CLIP(TempFileName)& '")]')
    DDECLOSE(SELF.DDEChannel)
    SELF.DDEChannel = DDECLIENT('Excel', CLIP(TempFileName))
  END
!--------------------------------------------------------------------
ExcelDDE.OutPutTable  PROCEDURE(STRING SheetName, LONG CellX, LONG CellY, LONG Border)
Count   LONG
  CODE
  DDEEXECUTE(SELF.DDEChannel, '[WORKBOOK.ACTIVATE("' & CLIP(SheetName) & '")]')
  DDEEXECUTE(SELF.DDEChannel, '[SELECT("R1C1:R1C1", "R1C1")]')
  IF RECORDS(SELF.RepVals)
    LOOP Count = 1 TO RECORDS(SELF.RepVals)
      GET(SELF.RepVals, Count)
      DDEEXECUTE(SELF.DDEChannel, |
                '[FORMULA.REPLACE("' & CLIP(SELF.RepVals.FindVal) &'", "' & |
                CLIP(SELF.RepVals.ReplVal) &'", 2, 1, False, False)]')
    END
  END
  SETCLIPBOARD(SELF.pOutStr)
  DDEEXECUTE(SELF.DDEChannel, '[SELECT("R' & CellX & 'C' & CellY & ':R' & CellX & 'C' & |
             CellY & '", "R' & CellX & 'C' & CellY & '")]')
  DDEEXECUTE(SELF.DDEChannel, '[PASTE.SPECIAL(1,1,1,1)]')
  IF ERRORCODE()
    DDEEXECUTE(SELF.DDEChannel, '[PASTE]')
  END
  IF Border = xlddeBorderOn
    DDEEXECUTE(SELF.DDEChannel, '[BORDER(2,1,1,1,1,0,0,0,0,0,0)]')
  END
  DDEEXECUTE(SELF.DDEChannel, '[SELECT("R1C1:R1C1", "R1C1")]')
!--------------------------------------------------------------------
ExcelDDE.AddReplaceValues    PROCEDURE(STRING fv, STRING rv)
  CODE
  SELF.RepVals.FindVal = fv
  SELF.RepVals.ReplVal = rv
  ADD(SELF.RepVals)
!--------------------------------------------------------------------
ExcelDDE.ResetReplaceValues  PROCEDURE
  CODE
  FREE(SELF.RepVals)
!--------------------------------------------------------------------
ExcelDDE.FreeCells PROCEDURE
  CODE
  SELF.pOutStr = ''
!--------------------------------------------------------------------
ExcelDDE.AddCell PROCEDURE
  CODE
  SELF.CheckLen(1)
  SELF.pOutStr = CLIP(SELF.pOutStr) & CHR(9)
!--------------------------------------------------------------------
ExcelDDE.AddCell             PROCEDURE(STRING Str)
  CODE
  SELF.CheckLen(LEN(Str))
  SELF.pOutStr = CLIP(SELF.pOutStr) & CLIP(Str) & CHR(9)
!--------------------------------------------------------------------
ExcelDDE.GotoNextRow PROCEDURE
  CODE
  SELF.CheckLen(2)
  SELF.pOutStr = SUB(SELF.pOutStr, 1, LEN(CLIP(SELF.pOutStr))-1) & CHR(13) & CHR(10)
!--------------------------------------------------------------------
ExcelDDE.CheckLen PROCEDURE(LONG AddedLen)
FullLen   LONG
UsedLen   LONG
  CODE
  FullLen = LEN(SELF.pOutStr)
  UsedLen = LEN(CLIP(SELF.pOutStr))
  IF FullLen - UsedLen <= AddedLen
    SELF.pSaveOutStr &= NEW(STRING(FullLen))
    SELF.pSaveOutStr = SELF.pOutStr
    DISPOSE(SELF.pOutStr)
    SELF.pOutStr &= NEW(STRING(FullLen + 1000))
    SELF.pOutStr = SELF.pSaveOutStr
    DISPOSE(SELF.pSaveOutStr)
  END
!--------------------------------------------------------------------
ExcelDDE.RunMacro  PROCEDURE(STRING MacroName)
  CODE
  DDEEXECUTE(SELF.DDEChannel, '[RUN("' & MacroName & '")]')
